KANBAN = {
    no: "https://manager.s21.weeke.app/",
    base: "everestmt",
    fetch: (API, onsuccess, post) => {
        var isObj = function (a) {
            if ((!!a) && (a.constructor === Object)) {
                return true;
            }
            return false;
        };
        var _st = function (z, g) {
            return "" + (g != "" ? "[" : "") + z + (g != "" ? "]" : "");
        };
        var fromObject = function (params, skipobjects, prefix) {
            if (skipobjects === void 0) {
                skipobjects = false;
            }
            if (prefix === void 0) {
                prefix = "";
            }
            var result = "";
            if (typeof (params) != "object") {
                return prefix + "=" + encodeURIComponent(params) + "&";
            }
            for (var param in params) {
                var c = "" + prefix + _st(param, prefix);
                if (isObj(params[param]) && !skipobjects) {
                    result += fromObject(params[param], false, "" + c);
                } else if (Array.isArray(params[param]) && !skipobjects) {
                    params[param].forEach(function (item, ind) {
                        result += fromObject(item, false, c + "[" + ind + "]");
                    });
                } else {
                    result += c + "=" + encodeURIComponent(params[param]) + "&";
                }
            }
            return result;
        };
        let data = null;
        let method = "GET";
        if (post) {
            method = "POST";
            data = fromObject(post)
        }
        if (!onsuccess)
            onsuccess = function (w) {
                console.log(w);
            }

        fetch("https://" + url.hostname + "/" + KANBAN.base + "/lite/" + API + "&ajax", {
            headers: {
                'Content-Type': 'application/json',
                'usuario': localStorage.kanban_user_id,
                'token': localStorage.kanban_user_token,
                'Content-Type': "application/x-www-form-urlencoded; charset=UTF-8"
            },
            method: method,
            body: data
        }).then(r => r.json()).then(r => {
            onsuccess(r);
        })
    },
    login: (token) => {
        fetch("https://chaveiro.weeke.com.br/v2/signin.php?json", {
            headers: {
                'x-auth-token': token,
                'Content-Type': 'application/json'
            }
        }).then(r => r.text()).then((data) => {

            let GERAL_USER = JSON.parse(data);
            if (GERAL_USER.id && GERAL_USER.id != 0 && GERAL_USER.session && GERAL_USER.access[KANBAN.base]) {
                APP.USER = (GERAL_USER.access[KANBAN.base]);
                APP.USER = GERAL_USER;
                fetch(APP.USER.access[KANBAN.base].url_login + "&token=" + token + "&debug", {
                    headers: {
                        'Content-Type': 'application/json'
                    }
                }).then(r => r.text()).then(r => {
                    url = new URLSearchParams(r);
                    if (url.get('u')) {
                        localStorage.kanban_user_id = url.get('u');
                        localStorage.kanban_user_token = url.get('token');

                        url = new URLPattern(APP.USER.access[KANBAN.base].url_login);
                        // https://kanban-dev.weeke.com.br/testedev/lite/json&usuario_info&base_info&ajax
                        KANBAN.fetch('json&usuario_info&base_info&ajax', function (r) {
                            if (r.usuario_info)
                                KANBAN.USUARIO = r.usuario_info;
                            if (r.base_info)
                                KANBAN.CONFIGURACAO = r.base_info;
                            localStorage.usuario = JSON.stringify(r.usuario_info);
                            localStorage.CONFIGURACAO = JSON.stringify(r.base_info);
                            APP.main("home");
                            if (document.querySelector('.top .avatar img')) {
                                document.querySelector('.top .avatar img').src = KANBAN.no + "/clientes/img.php?src=" + KANBAN.USUARIO.foto + "&h=52&w=52&zc=1";
                                document.querySelector('.top .avatar img').onclick = function () {
                                    if (confirm('Gostaria de faser logou?')) {
                                        localStorage.clear();
                                        window.location.reload()
                                    }
                                }
                            }
                            updateConfig = async () => {
                                let db = new Dexie('config');
                                db.version(1).stores({ global: '++key,value' });
                                await db.global.bulkPut([
                                    {
                                        "key": 'user',
                                        "value": localStorage.kanban_user_id,
                                    },
                                    {
                                        "key": 'token',
                                        "value": localStorage.kanban_user_token,
                                    },
                                    {
                                        "key": 'database',
                                        "value": KANBAN.base,
                                    },
                                    {
                                        "key": 'url',
                                        "value": KANBAN.no,
                                    }
                                ]);
                            };
                            updateConfig();
                        });
                    }
                })
                //https://manager.f1.weeke.com.br/login_token.php?base=welington
            } else {

                url = new URLSearchParams(window.location.search);
                if (url.get('token')) {
                    alert("O usuario não tem permição nesta base");
                    localStorage.clear();
                    window.location.href = "index.html";

                } else {
                    alert("Sem permição");
                    window.location.href = "index.html";
                }

                localStorage.clear();
            }

        });
    },
    onReady: {
        clientes: () => { },
        usuarios: () => { },
        tarefas: () => { },
        marcadores: () => { },
        tipos: () => { },
        status: () => { },
        setores: () => { },
    },
    sincronizar: {
        offline: () => {
            let carregar = async () => {

                let dados = (await APP.db.backgroundSync.toArray());
                document.querySelector("main .block.sync").dataset.total = dados.length;

                if (!KANBAN.modelo_item_sync)
                    KANBAN.modelo_item_sync = document.querySelector("main .block.sync .item").cloneNode(true);

                document.querySelectorAll("main .block.sync .item").forEach((item) => item.remove());

                dados.forEach((item) => {
                    let div = KANBAN.modelo_item_sync.cloneNode(true);
                    div.onclick = () => {
                        enviar(item);
                    }
                    div.querySelector("[data-bind='data']").innerHTML = new Date(item.datac).toLocaleDateString("pt-BR", { hour: '2-digit', minute: '2-digit' });
                    div.querySelector("[data-bind='tipo_nome']").innerHTML = (item.tipo_nome || "Novo Registro");
                    if (!item.tipo || item.tipo == "novo")
                        div.querySelector("[data-bind='id']").innerHTML = ("???");
                    div.querySelector("[data-bind='tipo_nome']").innerHTML = (item.tipo_nome || "Novo Registro");
                    div.dataset.ref = item.id;
                    document.querySelector("main .block.sync .list").append(div);
                    if (APP.ONLINE) {
                        enviar(item);
                    }
                });

                console.log(dados);
            }

            let enviar = async (dados) => {
                let formdata_pronto = console.log;
                let _formdata_pronto = 0;
                const URL_ENDPOINT_NOVA_TAREFA = 'https://manager.s21.weeke.app/everestmt/token/208709c35a4ea6a9a446f48d39112a06&op=cadastrar&sem_acompanhamento&json';// manager.s21.weeke.app kanban-dev.weeke.com.br
                console.warn(dados);
                const converter_base64_para_blob = async (base64) => {
                    let response = await fetch(base64);
                    const blob = await response.blob();
                    console.log(blob);
                    return blob;
                }
                let gerar_formdata = async function (dados) {
                    let form = new FormData();
                    Object.keys(dados.data).forEach(async (key) => {
                        let campo = dados.data[key];
                        if (campo.type == "file") {
                            if (campo.files.length) {
                                for (i = 0; i < campo.files.length; i++) {
                                    let file = campo.files[i];
                                    const fileblob = await converter_base64_para_blob(file.blob);
                                    form.append(key, fileblob, file.nome);

                                }
                            } else {
                                form.append(key, "");
                            }
                        } else {
                            form.append(key, campo.value);
                        }
                        _formdata_pronto++;
                        if (_formdata_pronto == Object.keys(dados.data).length) {
                            formdata_pronto(form);

                            console.log(_formdata_pronto, Object.keys(dados.data).length);
                        }
                    });
                }
                if (dados && dados.tabela == "tarefas") {
                    if (!dados.tipo || dados.tipo == "novo" && dados.formulario) {

                        formdata_pronto = (formdata) => {
                            //formdata.append('usuario',KANBAN.USUARIO.id);



                            let div = document.querySelector('main .block.sync .list .item.sync[data-ref="' + dados.id + '"]');
                            if (div.dataset.enviando == "true") {
                                alert("Já esta enviando..");
                            } else {
                                div.querySelector('[data-bind="id"]').innerHTML = "Enviando...";
                                div.dataset.enviando = true;
                                const request = new XMLHttpRequest();
                                request.open("POST", URL_ENDPOINT_NOVA_TAREFA, true);//'https://kanban-dev.weeke.com.br/index.php'
                                request.upload.addEventListener("progress", event => {
                                    // event.loaded returns how many bytes are downloaded
                                    // event.total returns the total number of bytes
                                    // event.total is only available if server sends `Content-Length` header
                                    div.querySelector('progress').max = event.total;
                                    div.querySelector('progress').value = event.loaded;
                                    console.log(`Downloaded ${event.loaded} of ${event.total} bytes`)
                                });
                                request.onload = (progress) => {
                                    div.querySelector('[data-bind="id"]').innerHTML = (
                                        request.status === 200
                                            ? "SALVO!"
                                            : `Error ${request.status}`);
                                    APP.db.backgroundSync.where('id').equals(parseInt(dados.id)).delete();
                                    KANBAN.sincronizar.automatico();
                                    div.remove();
                                    document.querySelector('main .block.sync[data-total]').dataset.total = document.querySelectorAll('main .block.sync .list .item.sync').length;
                                };
                                request.onerror = (progress) => {
                                    div.dataset.enviando = false;
                                    div.querySelector('[data-bind="id"]').innerHTML = "Erro ao enviar";
                                };

                                request.send(formdata);
                            }
                        }
                        await gerar_formdata(dados);

                    } else {

                    }
                }
            }
            //=====================
            carregar();
        },
        automatico: (force) => {
            KANBAN.fetch('registrador&ajax&TAREFA&CLIENTE&USUARIO&SETOR&GRUPO_CLIENTE&SERVICO&STATUS&TIPO_DE_TAREFA&MARCADOR', function (r) {
                if (force) {
                    localStorage.registrador_cliente = null;
                    localStorage.registrador_usuario = null;
                    localStorage.registrador_tarefas = null;
                    localStorage.registrador_marcadores = null;
                    localStorage.registrador_status = null;
                    localStorage.registrador_setores = null;
                }
                if (r.CLIENTE != localStorage.registrador_cliente)
                    KANBAN.sincronizar.clientes(r.CLIENTE);
                else
                    KANBAN.onReady.clientes();

                if (r.USUARIO != localStorage.registrador_usuario)
                    KANBAN.sincronizar.usuarios(r.USUARIO);
                else
                    KANBAN.onReady.usuarios();

                if (r.TAREFA != localStorage.registrador_tarefas)
                    KANBAN.sincronizar.tarefas(r.TAREFA);
                else
                    KANBAN.onReady.tarefas();

                if (r.MARCADOR != localStorage.registrador_marcadores)
                    KANBAN.sincronizar.marcadores(r.MARCADOR);
                else
                    KANBAN.onReady.marcadores();

                if (r.TIPO_DE_TAREFA != localStorage.registrador_tipos)
                    KANBAN.sincronizar.tipos(r.TIPO_DE_TAREFA);
                else
                    KANBAN.onReady.tipos();

                if (r.SETOR != localStorage.registrador_setores)
                    KANBAN.sincronizar.setores(r.SETOR);
                else
                    KANBAN.onReady.setores();

                if (r.STATUS != localStorage.registrador_status)
                    KANBAN.sincronizar.status(r.STATUS);
                else
                    KANBAN.onReady.status();

            });

        },
        clientes: (registrador) => {
            KANBAN.fetch('json&clientes_listar', async function (r) {
                localStorage.registrador_cliente = registrador;
                await APP.db.clientes.bulkPut(r.clientes_listar);
                console.log('clientes', r.clientes_listar);
                KANBAN.onReady.clientes();
            }, { config: { limite: 10000 } });

        },
        marcadores: (registrador) => {
            KANBAN.fetch('json&marcadores_listar', async function (r) {
                //==
                localStorage.registrador_marcadores = registrador;
                await APP.db.marcadores.bulkPut(r.marcadores_listar);
                console.log('marcadores', r.marcadores_listar);
                KANBAN.onReady.marcadores();
                //==
            });
        },
        tarefas: (registrador) => {
            KANBAN.fetch('json&tarefas_listar', async function (r) {
                //==
                if (r.tarefas_listar) {
                    await APP.db.tarefas.bulkPut(r.tarefas_listar);
                    localStorage.registrador_tarefas = registrador;
                    console.log('tarefas', r.tarefas_listar);
                }
                KANBAN.onReady.tarefas();
                //==
            }, { config: { limite: 100, registrador: (localStorage.registrador_tarefas || "") } });
        },
        usuarios: (registrador) => {
            KANBAN.fetch('json&usuarios_listar', async function (r) {
                localStorage.registrador_usuario = registrador;
                await APP.db.usuarios.bulkPut(r.usuarios_listar);
                console.log('usuarios', r.usuarios_listar);
                KANBAN.onReady.usuarios();
            }, { config: { limite: 10000 } });

        },
        tipos: (registrador) => {

            KANBAN.fetch('json&tipos_listar', async function (r) {
                localStorage.registrador_tipos = registrador;
                await APP.db.tipos.bulkPut(r.tipos_listar);
                console.log('tipos', r.tipos_listar);
                KANBAN.onReady.tipos();
            });

        },
        setores: (registrador) => {

            KANBAN.fetch('json&setores_listar', async function (r) {
                localStorage.registrador_setores = registrador;
                await APP.db.setores.bulkPut(r.setores_listar);
                KANBAN.onReady.setores();
            });

        },
        status: (registrador) => {

            KANBAN.fetch('json&status_listar', async function (r) {
                localStorage.registrador_status = registrador;
                await APP.db.status.bulkPut(r.status_listar);
                KANBAN.onReady.tipos();
            });

        }

    }
};
APP.configuration.database = {
    name: KANBAN.base,
    version: 9,
    schema: {
        clientes: '++id,status,nome,tipo',
        usuarios: '++id,usuario,email,nome,status',
        tipos: '++id,nome,setor,status',
        tarefas: '++id,usuario,tipo,status,setor,nome,datac,datae,datao,dataf,datau',
        configuration: 'chave',
        marcadores: '++id,titulo,setores',
        status: '++id,nome,cor,tipo,nivel,setor',
        setores: '++id,nome,cor',
        backgroundSync: '++id,tabela,chave,coluna,datac',
    }
}
APP.login = KANBAN.login;
APP.includes.home = (element) => {
    var instance = M.Tabs.init(document.querySelector('.tabs'));
    instance.updateTabIndicator();
    KANBAN.onReady.tarefas = async () => {
        document.querySelector('.loadig').hidden = true;
        let listar_setores = async () => {
            let setores = [];
            if (!KANBAN.modelo_tarefa)
                KANBAN.modelo_tarefa = document.querySelector("main .block.setor .list .item").cloneNode(true);
            document.querySelectorAll("main .block.setor .list .item").forEach(item => item.remove());
            if (!KANBAN.modelo_setor)
                KANBAN.modelo_setor = document.querySelector("main .block.setor").cloneNode(true);
            if (!KANBAN.modelo_setor_tab)
                KANBAN.modelo_setor_tab = document.querySelector("nav .tabs .tab").cloneNode(true);
            document.querySelectorAll("main .block.setor").forEach(item => item.remove());
            document.querySelectorAll("nav .tabs .tab").forEach(item => item.remove());

            if (KANBAN.USUARIO.nivel < 1) {
                // É ULTRA ADMIN
                setores = (await APP.db.setores.toArray());
                //setores = (await APP.db.setores.where('id').anyOf(['28','37']).toArray());
                setores = (await APP.db.setores.where('id').anyOf(['14']).toArray());
            } else {
                setores = (await APP.db.setores.where('id').anyOf((KANBAN.USUARIO.setor + (KANBAN.USUARIO.setores).trim()).split(",")).toArray());
                //setores = (await APP.db.setores.where('id').anyOf(['14']).toArray());
            }
            setores.forEach(async (setor) => {
                let novoSetor = KANBAN.modelo_setor.cloneNode(true);
                const novaTab = KANBAN.modelo_setor_tab.cloneNode(true);

                novaTab.querySelector('a').innerHTML = setor.nome;
                novaTab.querySelector('a').href = "#setor_" + setor.id;

                novoSetor.dataset.id = setor.id;
                novoSetor.id = "setor_" + setor.id;
                novoSetor.querySelector('.title').innerHTML = setor.nome;
                novoSetor.tarefas = [];
                novoSetor.carregarTarefas = (tarefas_filtradas) => {
                    if (!tarefas_filtradas)
                        tarefas_filtradas = novoSetor.tarefas;
                    const ordem = "datac desc";
                    if (ordem == 'datac desc')
                        tarefas_filtradas = tarefas_filtradas.sort((a, b) => (a.datac) < (b.datac) ? 1 : -1);
                    if (ordem == 'datau desc')
                        tarefas_filtradas = tarefas_filtradas.sort((a, b) => (a.datau) < (b.datau) ? 1 : -1);
                    if (ordem == 'datac asc')
                        tarefas_filtradas = tarefas_filtradas.sort((a, b) => (a.datac) > (b.datac) ? 1 : -1);
                    if (ordem == 'name')
                        tarefas_filtradas = tarefas_filtradas.sort((a, b) => (a.nome) < (b.nome) ? 1 : -1);

                    novoSetor.tarefas = tarefas_filtradas;
                    novaTab.dataset.total = novoSetor.tarefas.length;
                    for (var i = 0; i < novoSetor.tarefas.length && i < 11; i++) {
                        let tarefa = novoSetor.tarefas[i];
                        const novo = KANBAN.modelo_tarefa.cloneNode(true);
                        novo.detalhes = () => {
                            console.log(tarefa);
                            let div = document.querySelector('#details');
                            div.dataset.id = tarefa.id;
                            div.querySelectorAll('select[name="status"] option').forEach((e) => e.remove());
                            listarStatus = async () => {
                                let status = (await APP.db.status.where('setor').equals(tarefa.setor).toArray());
                                status.filter(s => parseInt(s.nivel) >= parseInt(KANBAN.USUARIO.nivel)).forEach((status) => {
                                    div.querySelector('select[name="status"]').append(new Option(status.nome, status.id));
                                });
                                div.querySelector('select[name="status"]').value = tarefa.status;
                            }
                            div.querySelectorAll('select[name="tipo"] option').forEach((e) => e.remove());
                            listarTipos = async () => {
                                let tipos = (await APP.db.tipos.toArray());

                                div.querySelector('select[name="tipo"]').append(new Option("Nenhum", "0"));
                                tipos.forEach((tipo) => {
                                    const setores = (tipo.setor.split(',')).map(e => parseInt(e));
                                    if (setores.includes(parseInt(tarefa.setor)))
                                        div.querySelector('select[name="tipo"]').append(new Option(tipo.nome, tipo.id));
                                });
                                div.querySelector('select[name="tipo"]').value = tarefa.tipo;
                            }
                            div.querySelectorAll('select[name="cliente"] option').forEach((e) => e.remove());
                            listarClientes = async () => {
                                let clientes = (await APP.db.clientes.toArray());

                                div.querySelectorAll('select[name="cliente"] option').forEach((e) => e.remove());
                                div.querySelector('select[name="cliente"]').append(new Option("Nenhum", "0"));
                                clientes.forEach((cliente) => {
                                    div.querySelector('select[name="cliente"]').append(new Option(cliente.nome_para_ordem + "", cliente.id));
                                });
                                div.querySelector('select[name="cliente"]').value = tarefa.cliente;
                            }
                            listarHistoricos = async () => {
                                if (!div.modelo_historico)
                                    div.modelo_historico = div.querySelector('.historico .item').cloneNode(true);
                                div.querySelectorAll('.historico .item').forEach((e) => e.remove());
                                tarefa.historico.sort((a, b) => (a.datac) < (b.datac) ? 1 : -1).forEach((historico) => {
                                    console.log(historico);
                                    const divHistorico = div.modelo_historico.cloneNode(true);
                                    divHistorico.querySelector('.user-name').innerHTML = historico.usuario_nome;
                                    divHistorico.querySelector('.date').innerHTML = historico.datac;
                                    if (APP.ONLINE)
                                        divHistorico.querySelector('.user-img img').src = KANBAN.CONFIGURACAO.URL_IMG_SERVIDOR + 'img.php?src=' + historico.usuario_foto;//https://arq.kanban.weeke.com.br/clientes/img.php?src=clientes/usuarios/homen.png&base=dGVzdGVkZXY&base=dGVzdGVkZXY
                                    divHistorico.querySelector('.texto').innerHTML = historico.texto;

                                    historico.classes.split(" ").forEach((classe) => { if (classe != "" && classe != " ") divHistorico.classList.add(classe); });
                                    divHistorico.querySelector('.texto');

                                    div.querySelector('.historico').append(divHistorico);
                                });
                            }
                            listarChecklist = async () => {
                                if (!div.modelo_checklist)
                                    div.modelo_checklist = div.querySelector('.checklists .item').cloneNode(true);
                                div.querySelectorAll('.checklists .item').forEach((e) => e.remove());
                                if (tarefa.checklist)
                                    tarefa.checklist.sort((a, b) => (a.ordem) > (b.ordem) ? 1 : -1).forEach((checklist) => {
                                        console.log(checklist);
                                        const divChecklist = div.modelo_checklist.cloneNode(true);
                                        divChecklist.querySelector('[name="descricao"]').value = checklist.descricao;
                                        divChecklist.querySelector('[name="status"]').checked = (checklist.concluido == "1") ? true : false
                                        div.querySelector('.checklists').append(divChecklist);
                                    });
                            }

                            //----------------
                            listarClientes();
                            listarTipos();
                            listarStatus();
                            listarHistoricos();
                            listarChecklist();

                            div.querySelector('.btnFechar').onclick = function () {
                                div.classList.remove('open');
                            }
                            if (div.classList.contains('open'))
                                div.classList.remove('open');
                            else
                                div.classList.add('open');
                            div.querySelectorAll('#details [data-bind]').forEach((element) => {
                                console.log(element);

                                if (element.tagName == "SELECT" && tarefa[element.dataset.bind]) {
                                    element.value = tarefa[element.dataset.bind];
                                } else
                                    if (tarefa[element.dataset.bind]) {
                                        element.innerHTML = tarefa[element.dataset.bind];
                                    }
                            });
                        }

                        novo.dataset.id = tarefa.id;
                        novo.style.borderLeftColor = tarefa.tipo_cor;
                        novo.querySelectorAll('.id strong').forEach((e) => {
                            e.innerHTML = "#" + tarefa.id;
                            e.style.color = tarefa.tipo_cor
                        });
                        novo.querySelectorAll('[data-bind="nome"]').forEach((e) => e.innerHTML = tarefa.nome);
                        if (tarefa.cliente_nome != "")
                            novo.querySelectorAll('[data-bind="cliente_nome"]').forEach((e) => e.innerHTML = tarefa.cliente_nome);
                        else
                            novo.querySelectorAll('.cliente').forEach((e) => e.classList.add('hide'));
                        if (tarefa.cliente_nome != "")
                            novo.querySelectorAll('[data-bind="cliente_endereco"]').forEach((e) => e.innerHTML = tarefa.cliente_endereco);
                        else
                            novo.querySelectorAll('.endereco').forEach((e) => e.classList.add('hide'));
                        novo.querySelectorAll('[data-bind="datae"]').forEach((e) => e.innerHTML = "" + new Date(tarefa.datae).toLocaleDateString("pt-br", {}));

                        novo.querySelectorAll('[data-bind="tipo_nome"]').forEach((e) => {
                            e.innerHTML = tarefa.tipo_nome;
                            e.style.color = tarefa.tipo_cor;
                        });
                        novo.querySelectorAll('[data-bind="status_nome"]').forEach((e) => e.innerHTML = tarefa.status_nome);

                        novo.dataset.statusTipo = tarefa.status_tipo;
                        novo.querySelector('.info').onclick = function () {
                            novo.detalhes();
                        };
                        novoSetor.querySelector('.list').append(novo);
                    };
                }


                let tarefas = (await APP.db.tarefas.where('setor').equals(setor.id).toArray());//.sort((a, b) => (a.id) < (b.id) ? 1 : -1)
                if (tarefas.length > 0) {
                    let tarefas_filtradas = tarefas.filter(i => {
                        if (i.datac > '2022') return i;
                    })
                    if (tarefas_filtradas.length) {
                        novoSetor.carregarTarefas(tarefas_filtradas);
                        document.querySelector("main").append(novoSetor);
                        document.querySelector("nav .tabs").append(novaTab);
                    }
                }
            });
            setTimeout(() => {
                document.querySelector(".tabs .tab a").click();
            }, 1000);
        }
        listar_setores();
        if (false)
            document.querySelector(".toolbar select[name=order]").onchange = function () {
                listar_setores();
            }
    }
    if (APP.ONLINE && !APP.USER) {
        window.location.href = "http://localhost/everest/index.html?token=72ea52326339f45065bb40458986a56c"; // ALTERAR AQUI
    } else if (APP.ONLINE && KANBAN.USUARIO) {
        if (APP.subscription && localStorage.subscription != JSON.stringify(APP.subscription)) {

            KANBAN.fetch('json&configuracao=API.WEBPUSH', function () {
                console.log(JSON.stringify(APP.subscription));
                localStorage.subscription = JSON.stringify(APP.subscription);
            }, { 'subscription': JSON.parse(JSON.stringify(APP.subscription)) });
        }
        KANBAN.sincronizar.automatico();

        document.querySelectorAll('.btnNew[data-url]').forEach((btn) => {
            btn.onclick = function () {
                APP.main(btn.dataset.url, document.querySelector("#frameNew"));
            }

        });

    } else {
        KANBAN.USUARIO = JSON.parse(localStorage.usuario);
        KANBAN.CONFIGURACAO = JSON.parse(localStorage.CONFIGURACAO);
        KANBAN.onReady.tarefas();

    }

    KANBAN.sincronizar.offline();
    document.querySelector('.btn_novo').onclick = function (e) {
        e.preventDefault();
        if (document.querySelector('#details').classList.contains("open"))
            window.location.href = 'novo_relatorio.html?ref=' + document.querySelector('#details').dataset.id;
        else
            window.location.href = 'novo_relatorio.html';
        console.log();
    }
}
APP.includes.novo_relatorio = (element) => {
    console.log('----->', element);
}