
var DADOS;
var URL_POST = 'test.php';
carregar_clientes = (async () => {
    let clientes = (await APP.db.clientes.toArray());
    document.querySelectorAll('select[data-bind="cliente"]').forEach(select => {
        select.onchange = function () { };
        select.querySelectorAll('option').forEach((e) => e.remove());
    });
    clientes.forEach((cliente) => {
        document.querySelector('select[name="campo345"]').append(new Option(cliente.nome_para_ordem + "", cliente.id));
    });
    document.querySelector('select[name="campo345"]').onchange = async function () {
        let cliente = (await (APP.db.clientes.where("id").anyOf(document.querySelector('select[name="campo345"]').value).toArray()))[0];
        document.querySelector('[name="campo346"]').value = cliente.cidade + "," + cliente.estado + " - " + cliente.endereco;
        if (cliente.responsavel != "")
            document.querySelector('[name="campo348"]').value = cliente.responsavel;
        console.log(cliente);
    }
    //div.querySelector('select[name="campo345"]').value = tarefa.cliente;
});
carregar_usuarios = (async () => {
    let usuarios = (await APP.db.usuarios.toArray());
    document.querySelectorAll('select[data-bind="usuario"]').forEach(select => {
        select.onchange = function () { };
        select.querySelectorAll('option').forEach((e) => e.remove());
        select.append(new Option(""));
        usuarios.forEach((usuario) => {
            let setores = (usuario.setores).split(",");
            setores.push(usuario.setor);
            if (setores.includes('28') && usuario.status == "1") {
                var opt = new Option(usuario.nome + "", usuario.nome);
                opt.dataset.id = usuario.id;
                select.append(opt);
            }
        });
    });
});
salvar_dados = async (data) => {
    await APP.db.backgroundSync.put({ tabela: "tarefas", tipo: 'novo', tipo_nome: "Nova abertura de chamados", data: data, datac: new Date(), formulario: 6 });
    window.location.href = "index.html";
}
function carregar_eventos() {

    document.querySelector("#form_tarefa_criar").onsubmit = async (e) => {
        document.querySelectorAll("#form_tarefa_criar [name],#form_tarefa_criar button").forEach((input) => input.disabled = true);
        e.preventDefault();
        const data = {};
        document.querySelectorAll("#form_tarefa_criar [name]").forEach((input) => {
            data[input.name] = {
                type: input.type
            }
            if (input.type == 'file') {
                data[input.name].files = [];
                for (var i = 0; i < input.files.length; i++) {
                    let file = input.files[i];
                    file.blob = input.blob;
                    //console.log(input.blob);
                    data[input.name].files.push({ nome: file.name, tamanho: file.size, tipo: file.type, blob: input.blob });
                }

            } else if (input.type == "checkbox" && input.checked == false) {

            } else {
                if (input.value)
                    data[input.name].value = input.value;
                else
                    data[input.name].value = "";
            }
        });
        data.cliente = data.campo345;
        let usuarios = [];
        if ("" != ((document.querySelector('select[name="campo401"]').value != "") ? document.querySelector('select[name="campo401"]').selectedOptions[0].dataset.id : '')) {
            usuarios.push(document.querySelector('select[name="campo401"]').selectedOptions[0].dataset.id);
            data.usuario = { type: 'text', value: document.querySelector('select[name="campo401"]').selectedOptions[0].dataset.id };
        }
        if ("" != ((document.querySelector('select[name="campo402"]').value != "") ? document.querySelector('select[name="campo402"]').selectedOptions[0].dataset.id : ''))
            usuarios.push(document.querySelector('select[name="campo402"]').selectedOptions[0].dataset.id);
        if (usuarios.length > 0)
            data.usuarios = { type: 'text', value: usuarios.join(',') };
        if (!data.usuario || data.usuario == "" && false)
            data.usuario = { type: 'text', value: (KANBAN.USUARIO.id || localStorage.kanban_user_id || "1") };
        if (REF && REF != "")
            data.relacao = { type: 'text', value: REF };
        salvar_dados(data);
    }
    const lista_de_material_btns = () => {
        const max = document.querySelectorAll("#form_tarefa_criar .lista_de_material .item").length;
        let visivel = 0;
        const check = () => {
            if (visivel <= max) {
                document.querySelectorAll("#form_tarefa_criar .lista_de_material .item").forEach((ele, i) => {
                    if (visivel > i) {
                        ele.classList.add("mostrar");
                    } else {
                        ele.classList.remove("mostrar");
                    }
                });
            } else {
            }
        }
        check();
        document.querySelector("#form_tarefa_criar .lista_de_material .btn-new-item").onclick = function () {
            visivel++;
            check();
            if (visivel >= max)
                document.querySelector("#form_tarefa_criar .lista_de_material .btn-new-item").disabled = true;
            else
                document.querySelector("#form_tarefa_criar .lista_de_material .btn-new-item").disabled = false;
        }
    }
    lista_de_material_btns();
    const lista_de_evidencias_btns = () => {
        const max = document.querySelectorAll("#form_tarefa_criar .lista_de_evidencias fieldset").length;
        let visivel = 0;
        const check = () => {
            if (visivel <= max) {
                document.querySelectorAll("#form_tarefa_criar .lista_de_evidencias fieldset").forEach((ele, i) => {
                    if (visivel > i) {
                        ele.classList.add("mostrar");
                    } else {
                        ele.classList.remove("mostrar");
                    }
                });
            } else {
            }
        }
        check();
        document.querySelector("#form_tarefa_criar .lista_de_evidencias .btn-new-item").onclick = function () {
            visivel++;
            check();
            if (visivel >= max)
                document.querySelector("#form_tarefa_criar .lista_de_evidencias .btn-new-item").disabled = true;
            else
                document.querySelector("#form_tarefa_criar .lista_de_evidencias .btn-new-item").disabled = false;
        }
    }
    lista_de_evidencias_btns();
    document.querySelectorAll("#form_tarefa_criar [name][type='file']").forEach((input) => {
        var fileReader = new FileReader();
        fileReader.onloadend = function (e) {
            var arrayBuffer = e.target.result;
            input.blob = arrayBuffer;
            console.log("OK");
        };
        input.onchange = function () {
            var file = input.files[0];
            if (file) {
                fileReader.readAsDataURL(file);

            } else {

            }
        }
    });
}
//
async function carregar_cartao(REF) {
    const cartao = (await APP.db.tarefas.where('id').equals(REF).toArray())[0];
    if (cartao) {
        console.log(cartao);
        document.querySelector('.lista_de_detalhes_do_cartao').dataset.id = cartao.id;
        if (cartao.cliente != "0") {
            document.querySelector('select[name="campo345"]').value = cartao.cliente;
            document.querySelector('select[name="campo345"]').onchange();
        }
        if (cartao.usuario != "0") {
            document.querySelector('select[name="campo401"] [data-id="' + cartao.usuario + '"]').selected = true;
            document.querySelector('select[name="campo401"]').onchange();
        }
        document.querySelector('.in_texto').innerHTML = cartao.texto;
    }
}
const REF = new URLSearchParams(window.location.search).get('ref');
APP.main = function () {

    carregar_eventos();
    carregar_clientes();
    carregar_usuarios();
    if (REF) {
        carregar_cartao(REF);
    }
}
