<?php
require __DIR__ . '/vendor/autoload.php';
$subscription = json_decode('{"endpoint":"https://fcm.googleapis.com/fcm/send/eyBc8hN2Ssw:APA91bHdWuKorrrGNGBVtzuIgBbFDi_7IjFdRKAmZDYIxlkWfwPBZLRNsNkemf-z3mj-vUiEinViJbx4GykODa-6-ZHbP-o5df7kiGc7stDWlfVEnWIV1f0epIyoIbW71Zg7Fh2_x8Yc","expirationTime":null,"keys":{"p256dh":"BD0-xpylpXQZ7bKVHUoIaeEzhKrhjWKf1ctvnYrkitnyB6yQZjJB6eP0AXXkotBcn3lwuE5S4tByqtGoan5LTA4","auth":"qMs45EC4aelRb5LG77pY3g"}}');

ini_set('display_errors', 1);
error_reporting(E_ALL ^ E_NOTICE);

use Minishlink\WebPush\WebPush;
use Minishlink\WebPush\Subscription;

// array of notifications
/*

{"endpoint":"https://fcm.googleapis.com/fcm/send/fTYop3rskVM:APA91bFL84lG7VjqbY6xZlcPC50kw1a_rsjOImcymliXsG99fWtqqO_cUx-gsFfa73cnpX-m0iPABoGZn7AXnWOINVG_fVo0h3QPjzSOcf4EnVIIXM0Q_ZKUpm_G8EhwgAEGRi8eNaYC","expirationTime":null,"keys":{"p256dh":"BC-LfoNuitHpGTtsuS0qU7AU493QFZH-sK5oJNz5TApzCcMA3cNVXzC_arbTrOz6ukn39jLEmQs1s0vJEBvOCr0","auth":"bLu5dDvz358sIqu0mbTIow"}}

*/

$notifications = [
     [
          'subscription' => Subscription::create([ // this is the structure for the working draft from october 2018 (https://www.w3.org/TR/2018/WD-push-api-20181026/) 
              "endpoint" => $subscription->endpoint,
              "keys" => [
                  'p256dh' =>  $subscription->keys->p256dh,
                  'auth' => $subscription->keys->auth
              ],
          ]),
          'payload' => '{"msg":"Hello World!","action":["syncContent"]}',
      ],
];
$auth = [
    'VAPID' => [
        'subject' => 'mailto:me@website.com', // can be a mailto: or your website address
        'publicKey' => 'BM1aWwz5kDKthYBjSuKN8wI2S3umNDUiGyZbU2A3eZDelr0Hbh8QkeWYtQLxgMdiwPaEO7HLJCarMQyAMmjb-J8', // (recommended) uncompressed public key P-256 encoded in Base64-URL
        'privateKey' => 'v8XOMN2brfdBEcEeLaBM51h3SvmdyyCt8CPH2UN0WqM', // (recommended) in fact the secret multiplier of the private key encoded in Base64-URL
    ],
];
$webPush = new WebPush($auth);

// send multiple notifications with payload
foreach ($notifications as $notification) {
    $webPush->queueNotification(
        $notification['subscription'],
        $notification['payload'] // optional (defaults null)
    );
}

/**
 * Check sent results
 * @var MessageSentReport $report
 */
foreach ($webPush->flush() as $report) {
    $endpoint = $report->getRequest()->getUri()->__toString();

    if ($report->isSuccess()) {
        echo "[v] Message sent successfully for subscription {$endpoint}.";
    } else {
        echo "[x] Message failed to sent for subscription {$endpoint}: {$report->getReason()}";
    }
}

